/* (C) 2000-2001 Grafixoft Email a@oo.ms */
/* see file COPYRIGHT for info */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/file.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
#define RX

#include "gsm2.h"
extern int audiostream;
extern int dspqueueout;
extern int latency;
extern int recode(char *src, char *dest, int style, int data, int code);
extern int openstream(int style,int way, int dspspeed);

#define DSP_WATERMARK 2
#define MAX_PACKS 18
#define BLOCK_INC 6
#define MAX_BUMPS 5


int decode(char *data, char *playbuf, int bgsm, int audiotype)
{
	int i;
	char *kut=data;
	gsm_signal buf[bgsm*320];
	gsm_signal *kuf=buf;
	
	memset((void *)buf, 0, bgsm*160);
	/* do left and right independently */
	if(audiotype<0x80) {
		for (i=0; i<bgsm; i++) {
			if (gsm_decode(hndle, (gsm_byte *)kut, kuf)==-1) {
				memset((void *)kuf,0,320); /* absolute silence if there is an error */
				printf("\r\nDecoder Error!\r\n");
			}
			kut+=33;
			kuf+=160;
		}
	} else {
		for (i=0; i<(bgsm/2); i++) {
			if (gsm_decode(hndle, (gsm_byte *)kut, kuf)==-1) {
				memset((void *)kuf,0,320); /* absolute silence if there is an error */
				printf("\r\nDecoder Error!\r\n");
			}
			kut+=33;
			kuf+=160;
		}
		for (; i<bgsm; i++) {
			if (gsm_decode(gsmh, (gsm_byte *)kut, kuf)==-1) {
				memset((void *)kuf,0,320); /* absolute silence if there is an error */
				printf("\r\nDecoder Error!\r\n");
			}
			kut+=33;
			kuf+=160;
		}
	} 
	return recode((char *)&buf,playbuf,audiotype,bgsm,1);
}

void dataplay(unsigned char *info,int blocks, int audiotype) 
{
	char *pbuf;

	pbuf=malloc(320*blocks);
	/* pbuf=alloca(320*blocks); stack alloc has "issues" sometimes  :-) */
	/* what's gonna be played anyhow? */
	decode(info, pbuf, blocks, audiotype);
	free(pbuf);
	return;

}


int rx(int audiost)
{
	int dsp=8000;
	int i;
	unsigned long long bytes=0;
	int a=0;
	int decided=250;
	char other[20];
	int audopen=0;
	time_t oldtime, newtime, lasttime;
	unsigned char datapack[BGSM+2];
	unsigned char *outpack;
	char *puke;
	int audiostyle=audiost & 0xff;
	int fuqed;
	int oldpacks = 0;
	int expectedpacks = 0; /* Prevent change request */
	int networkbump=0;

	if(audiostyle >= 0x80) dsp=20000;
	lock=0;
	decided=0;
	kanker=buffie;
	oldtime=time(NULL);
	lasttime=oldtime;
	dspqueueout=0;
	
	for (;;) {
		if(onfile != 0) {
			fuqed=1;
		} else {
			FD_ZERO(&rd); FD_SET(sock,&rd);
			(void) select (FD_SETSIZE, &rd, NULL, NULL, &mydelay);
			fuqed=FD_ISSET(sock,&rd);
		}
		if(fuqed) {

			read(sock,(void *) &decider, 1);
			bytes++;
			switch(decider & 0xff) {

				case 0:
					printf("Remote requested disconnect\n");
					cclosed();
					return(3);
					break;

				case 1: /* rx/tx turnaround */
					return(1); /* modus return */
					break;

				case 2: /* inbound text */
					read(sock,(void *) &keyin, 1);
					bytes++;
					if( (keyin < 32) && (keyin != 10)  && (keyin != 8)) keyin=32;
					printf("%c",keyin);
					break;
				case 3: /* gsm packages */
					/* this is the proper place to request a bump in pack sizes --AJK */
					if((dspqueueout < DSP_WATERMARK) && ((onfile == 0) && (oldpacks != 0) && (expectedpacks > 0) && (networkbump > MAX_BUMPS))) {
						if((expectedpacks == oldpacks) && (oldpacks < MAX_PACKS )) {
							expectedpacks+=BLOCK_INC;
							sprintf(other, "\012%c", expectedpacks);
							write(sock, other, 2);
							bytes+=2;
							printf("\nasking for %i packs\n",expectedpacks);
						}
					}
					if(dspqueueout<DSP_WATERMARK) {
						networkbump++;
					} else {
						networkbump=0;
					}
					read(sock,(void *) &keyin, 1);
					bytes++;
					packs=keyin & 0xff;
					oldpacks = packs;
					if(expectedpacks==0) expectedpacks=packs;
					kanker=buffie;
					if((packs != expectedpacks) && (expectedpacks!=0)) {
						printf("\nWaiting for bigger packs sync, got %i, want %i\n",packs,expectedpacks);
					}
					for(i=0;i<packs*33;) {
						a=read(sock, (void *)kanker, (packs*33)-i);
						i+=a;
						kanker+=a;
						bytes+=a;
					}
					if (audopen==1) {
						kanker=buffie;
						dataplay(kanker,packs,audiostyle);
					}
					break;

				case 4: /* audio type change, this has to be the first packet! */
					read(sock,(void *) &audiostyle, 1);
					bytes++;
					if (audopen==1) close(audiostream);
					expectedpacks=0;
					audiostyle=openstream(audiostyle&0xff,1,dsp) & 0xff;
					sprintf(other,"\004%c",audiostyle&0xff);
					if(onfile == 0) write(sock,(void *)&other,2);
					audopen=1;
					break;

				case 5:
					if (audopen==1) close(audiostream);
					expectedpacks=0;
					dsp+=DSPCHANGE;
					outpack=datapack;
					puke=outpack;
					*puke=0x04;
					puke++;
					*puke=audiostyle & 0xff;
					if(onfile == 0) write(sock,outpack,2);
					audiostyle=openstream(audiostyle&0xff,1,dsp) & 0xff;
					audopen=1;
					break;

				case 6:
					if (audopen==1) close(audiostream);
					expectedpacks=0;
					dsp-=DSPCHANGE;
					outpack=datapack;
					puke=outpack;
					*puke=0x04;
					puke++;
					*puke=audiostyle & 0xff;
					if(onfile == 0) write(sock,outpack,2);
					audiostyle=openstream(audiostyle&0xff,1,dsp) & 0xff;
					audopen=1;
					break;
					
				case 8:
					/* dsp speed force request sync */
					expectedpacks=0;
					if (audopen==1) close(audiostream);
					read(sock,(void *) &dsp, 2);
					read(sock,(void *) &audiostyle, 1);
					bytes+=3;
					/* send _REQUEST_ back as an ack to sync */
					sprintf(other,"\010%c%c%c",dsp&0xff,(dsp>>8)&0xff,audiostyle);
					if(onfile == 0) write(sock,(void *)&other,4);
					audopen=0; /* will not open untill 0x04 request comes back */
					break;

				default: /* huh?? */
					break;

			} /* switch */
		} else {
			usleep(1);
		} /* end of socket test */
		newtime = time(NULL);
		if(bytes == 0) {
			/* sync */
			lasttime=newtime;
			oldtime=newtime;
		}
		if(onfile != 0) {
			key=0;
			FD_ZERO(&rd);
			FD_SET(fileno(stdin),&rd);
			(void) select (FD_SETSIZE, &rd, NULL, NULL, &mydelay);
			/* check for exit (^A), other stuff soon to come... */
			if(FD_ISSET(fileno(stdin),&rd)) {
				read (fileno(stdin),(void *) &key, 1);
				switch(key & 0xff) {
					case 1:
						cclosed();
						return(3);
						break;
				

					default:
						if((key < 32) && (key != 10) && (key != 8)) key=32;
						printf("%c",key);
						fflush(stdout);
						break;
				}
			}
			if ((newtime-oldtime)>0) printf("\rRW bandwidth: %.2f bytes/sec, time %lu:%2.2lu, bytes %llu       ",(float)bytes/(newtime-oldtime),(newtime-oldtime)/60,(newtime-oldtime)-(((newtime-oldtime)/60)*60),bytes);
			fflush(stdout);
		} else {
			key=0;
			FD_ZERO(&rd);
			FD_SET(fileno(stdin),&rd);
			(void) select (FD_SETSIZE, &rd, NULL, NULL, &mydelay);
			/* check for exit (^A), other stuff soon to come... */
			if(FD_ISSET(fileno(stdin),&rd)) {
				read (fileno(stdin),(void *) &key, 1);
				switch(key & 0xff) {
					case 1:
						write(sock,"\000",1);
						bytes++;
						sleep(2);
						cclosed();
						return(3);
						break;
				
					case 9:
						if(bytes > 0) {
							printf("RW bandwidth: %.2f bytes/sec, time %lu:%2.2lu, bytes %llu       ",(float)bytes/(newtime-oldtime),(newtime-oldtime)/60,(newtime-oldtime)-(((newtime-oldtime)/60)*60),bytes);
							printf("\n");
						} else {
							printf("No data yet!\n");
						}
						break;
	
					/* *REQUEST* data rate changes */
					case 21: /* ^U */
						write(sock,"\005",1);
						break;
				
					case 25: /* ^Y */
						write(sock,"\006",1);
						break;

					case 24: /* ^X */
						/* _REQUEST_ adjust dsp speed/stereo toggle */
						if(audiostyle < 0x80 ) {
							sprintf(other,"\011%c%c%c",(dsp/2)&0xff,((dsp/2)>>8)&0xff,audiostyle ^0x80);
						} else {
							sprintf(other,"\011%c%c%c",(dsp*2)&0xff,((dsp*2)>>8)&0xff,audiostyle ^0x80);
						}
						write(sock,(void *)&other,4);
						break;

					default:
						if((key < 32) && (key != 10) && (key != 8)) key=32;
						printf("%c",key);
						fflush(stdout);
						sprintf(other,"\002%c",key);
						write(sock,(void *)&other,2);
						bytes+=2;
						break;
				}
			}
		}
	} /* for(;;) */
}

